Package: ASEB
Title: Predict Acetylated Lysine Sites
Version: 1.57.0
Author: Likun Wang <wanglk@hsc.pku.edu.cn> and Tingting Li <litt@hsc.pku.edu.cn>.
Description: ASEB is an R package to predict lysine sites that can be acetylated by a specific KAT-family.
Maintainer: Likun Wang <wanglk@hsc.pku.edu.cn>
Depends: R (>= 2.8.0), methods
Imports: graphics, methods, utils
License: GPL (>= 3)
biocViews: Proteomics
Collate: AllClasses.R AllGenerics.R SequenceInfo.R readSequence.R
        asebSites.R asebProteins.R drawStat.R drawEScurve.R
LazyLoad: yes
git_url: https://git.bioconductor.org/packages/ASEB
git_branch: devel
git_last_commit: d3a5183
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: yes
Packaged: 2026-04-28 21:15:39 UTC; biocbuild

readSequence <- function(file){
   rd <- read.table(file, fill=TRUE,sep="")
   rd <- as.matrix(rd)
   sequences <- ""
   ids <- ""
   id <- ""
   sequence <- ""
   count <- 0
   for(i in (1:nrow(rd))){
       line <- as.vector(rd[i,])
       if(length(grep(">", line[1])) > 0){
          if(id != ""){
             count <- count+1
             ids[count] <- id
             sequences[count] <- sequence
          }
          if(nchar(line[1]) > 1){
             id <- substring(line[1],2) 
          }else{
             id <- line[2]
          }
          sequence <- ""
       }else{
          for(j in (1:length(line))){
              if(is.na(line[j])){
                 break
              }
              sequence <- paste(sequence, line[j], sep="")
              sequence <- gsub("\\s+","",sequence)
          }
       }
   }
   if(id != ""){
      count <- count+1
      ids[count] <- id
      sequences[count] <- sequence
   }
   SequenceInfo(sequences, ids)
}

### R code from vignette source 'ASEB.Rnw'

###################################################
### code chunk number 1: ASEB.Rnw:78-81
###################################################
  library(ASEB)
  ff <- system.file("extdata", "background_sites.fa", package="ASEB")
  readSequence(ff)


###################################################
### code chunk number 2: ASEB.Rnw:89-94
###################################################
  backgroundSites <- readSequence(system.file("extdata", "background_sites.fa", package="ASEB")) 
  prodefinedSites <- readSequence(system.file("extdata", "predefined_sites.fa", package="ASEB"))
  testSites <- readSequence(system.file("extdata", "sites_to_test.fa", package="ASEB"))
  resultList <- asebSites(backgroundSites, prodefinedSites, testSites, permutationTimes=100)
  resultList$results[1:2,]


###################################################
### code chunk number 3: ASEB.Rnw:101-105
###################################################
  backgroundSitesFile <- system.file("extdata", "background_sites.fa", package="ASEB")
  prodefinedSitesFile <- system.file("extdata", "predefined_sites.fa", package="ASEB")
  testSitesFile <- system.file("extdata", "sites_to_test.fa", package="ASEB")
  asebSites(backgroundSitesFile, prodefinedSitesFile, testSitesFile, permutationTimes=100)


###################################################
### code chunk number 4: ASEB.Rnw:113-114
###################################################
  drawEScurve(resultList$curveInfo, max_p_value=0.1, min_es=0.1)


###################################################
### code chunk number 5: ASEB.Rnw:124-129
###################################################
  backgroundSites <- readSequence(system.file("extdata", "background_sites.fa", package="ASEB")) 
  prodefinedSites <- readSequence(system.file("extdata", "predefined_sites.fa", package="ASEB"))
  testProteins <- readSequence(system.file("extdata", "proteins_to_test.fa", package="ASEB"))
  resultList <- asebProteins(backgroundSites, prodefinedSites, testProteins, permutationTimes=100)
  resultList$results[1:2,]


###################################################
### code chunk number 6: ASEB.Rnw:134-138
###################################################
  backgroundSitesFile <- system.file("extdata", "background_sites.fa", package="ASEB")
  prodefinedSitesFile <- system.file("extdata", "predefined_sites.fa", package="ASEB")
  testProteinsFile <- system.file("extdata", "sites_to_test.fa", package="ASEB")
  asebProteins(backgroundSitesFile, prodefinedSitesFile, testProteinsFile, permutationTimes=100)


###################################################
### code chunk number 7: ASEB.Rnw:146-147
###################################################
  drawStat(curveInfoDataFrame=resultList$curveInfo);

setMethod(asebProteins, c("character","character","character"),
function(backgroundSites, prodefinedSites, testProteins, outputFile, permutationTimes=10000)
{   
    if(is.null(outputFile[1])){
       outputFile <- paste(tempdir(),"/","outputFile",sep="")
    }
    cat("Please wait patiently!\n")
    kk <- .C(".asebC",as.character(backgroundSites),as.character(prodefinedSites), as.character(testProteins), as.character(outputFile),as.integer(permutationTimes),as.integer(1))
})

setMethod(asebProteins, c("SequenceInfo", "SequenceInfo", "SequenceInfo"),
function(backgroundSites, prodefinedSites, testProteins, outputFile=NULL, permutationTimes=10000)
{
    backgroundSitesSeqs <- sequences(backgroundSites)
    backgroundSitesIds <- ids(backgroundSites)
    prodefinedSitesSeqs <- sequences(prodefinedSites)
    prodefinedSitesIds <- ids(prodefinedSites)
    testProteinsSeqs <- sequences(testProteins)
    testProteinsIds <- ids(testProteins)
    backgroundSitesFile <- paste(tempdir(),"/","backgroundSitesFile",sep="")
    prodefinedSitesFile<- paste(tempdir(),"/","prodefinedSitesFile",sep="")
    testProteinsFile<- paste(tempdir(),"/","testProteinsFile",sep="")
    if(is.null(outputFile[1])){
       outputFile <- paste(tempdir(),"/","outputFile",sep="")
    }
    
    backgroundSitesIds <- paste(">", backgroundSitesIds, sep = "")
    prodefinedSitesIds <- paste(">", prodefinedSitesIds, sep = "")
    testProteinsIds <- paste(">", testProteinsIds, sep = "")
    testProteinsSeqs <- split2ShortMers2(testProteinsSeqs)
    
    write.table(file=backgroundSitesFile, cbind(backgroundSitesIds,backgroundSitesSeqs),row.names = FALSE,col.names = FALSE,quote = FALSE,sep="\n")
    write.table(file=prodefinedSitesFile, cbind(prodefinedSitesIds,prodefinedSitesSeqs),row.names = FALSE,col.names = FALSE,quote = FALSE,sep="\n")
    write.table(file=testProteinsFile, cbind(testProteinsIds,testProteinsSeqs),row.names = FALSE,col.names = FALSE,quote = FALSE,sep="\n")
    asebProteins(backgroundSitesFile, prodefinedSitesFile, testProteinsFile, outputFile, permutationTimes)
    curveInfoFile <- paste(outputFile, ".curves",sep="")
    results <- read.table(outputFile,header=FALSE,sep="\t")
    colnames(results)[1:3] <- c("site", "ES", "p-value")
    curveInfo <- read.table(curveInfoFile,header=FALSE)
    colnames(curveInfo)[1] <- c("site")
    return(list(results=results, curveInfo=curveInfo))
})

setMethod(asebSites, c("character","character","character"),
function(backgroundSites, prodefinedSites, testSites, outputFile, permutationTimes=10000)
{   
    if(is.null(outputFile[1])){
       outputFile <- paste(tempdir(),"/","outputFile",sep="")
    }
    cat("Please wait patiently!\n")
    kk <- .C(".asebC",as.character(backgroundSites),as.character(prodefinedSites), as.character(testSites),as.character(outputFile),as.integer(permutationTimes),as.integer(0))
})

split2ShortMers <- function(longString, merLen=50, sep="\n"){
    i <- 1
    len <- nchar(longString)
    mers <- "";
    while(i <= len){
        mer50 <- substr(longString, i, i+merLen-1)
        if(i==1){
           mers <- mer50
        }else{
           mers <- paste(mers, mer50, sep=sep)
        }
        i <- i+merLen
    }
    mers
}
split2ShortMers2 <- function(longStrings, merLen=50, sep="\n"){
    sapply(longStrings, function(x) split2ShortMers(x,merLen=merLen, sep=sep))
}

setMethod(asebSites, c("SequenceInfo", "SequenceInfo", "SequenceInfo"),
function(backgroundSites, prodefinedSites, testSites, outputFile=NULL, permutationTimes=10000)
{
    backgroundSitesSeqs <- sequences(backgroundSites)
    backgroundSitesIds <- ids(backgroundSites)
    prodefinedSitesSeqs <- sequences(prodefinedSites)
    prodefinedSitesIds <- ids(prodefinedSites)
    testSitesSeqs <- sequences(testSites)
    testSitesIds <- ids(testSites)
    backgroundSitesFile <- paste(tempdir(),"/","backgroundSitesFile",sep="")
    prodefinedSitesFile<- paste(tempdir(),"/","prodefinedSitesFile",sep="")
    testSitesFile<- paste(tempdir(),"/","testSitesFile",sep="")
    if(is.null(outputFile[1])){
       outputFile <- paste(tempdir(),"/","outputFile",sep="")
    }
    
    backgroundSitesIds <- paste(">", backgroundSitesIds, sep = "")
    prodefinedSitesIds <- paste(">", prodefinedSitesIds, sep = "")
    testSitesIds <- paste(">", testSitesIds, sep = "")
        
    write.table(file=backgroundSitesFile, cbind(backgroundSitesIds,backgroundSitesSeqs),row.names = FALSE,col.names = FALSE,quote = FALSE,sep="\n")
    write.table(file=prodefinedSitesFile, cbind(prodefinedSitesIds,prodefinedSitesSeqs),row.names = FALSE,col.names = FALSE,quote = FALSE,sep="\n")
    write.table(file=testSitesFile, cbind(testSitesIds,testSitesSeqs),row.names = FALSE,col.names = FALSE,quote = FALSE,sep="\n")
    asebSites(backgroundSitesFile, prodefinedSitesFile, testSitesFile, outputFile, permutationTimes)
    curveInfoFile <- paste(outputFile, ".curves",sep="")
    results <- read.table(outputFile,header=FALSE)
    colnames(results)[1:3] <- c("site", "ES", "p-value")
    curveInfo <- read.table(curveInfoFile,header=FALSE,sep="\t")
    colnames(curveInfo)[1] <- c("site")
    return(list(results=results, curveInfo=curveInfo))
})

setMethod(drawEScurve, "data.frame",
function(curveInfoDataFrame, sites=NULL, max_p_value=0.1, min_es=0.2, outputDir=NULL, figKind=c("pdf","jpeg"))
{ 
  rt <- curveInfoDataFrame
  nrow(rt)/2
  name2name <- c()
  name2name[sites]<- sites
  if((!is.null(outputDir[1]))||(length(outputDir) > 1)){
      figKind <- match.arg(figKind)
      dir.create(outputDir[1], showWarnings = FALSE, recursive = TRUE)
      #cat("create ", outputDir[1], "\n")
      if(file.access(outputDir, mode = 0) != 0){
         cat("warning: can not creat ", outputDir)
      }else{
         #cat("create down", outputDir[1], "\n")
      }
  }else{
      figKind <- "none"
  }
  #cat(figKind,"\t")
  for(i in (1:(nrow(rt)/2))){
      ES <- rt[i*2-1,ncol(rt)-1]
      p_value <- rt[i*2-1,ncol(rt)]
      if((!is.null(sites[1]))||(length(sites) > 1)){
         proteinName <- as.vector(rt[i*2-1,1])
         if(is.null(name2name[proteinName])){
            next
         }
      }
      #cat(as.vector(rt[i*2-1,1]), " ES:",ES," p_value:",p_value,"\n")
      if(ES < min_es){
         next
      }
      if(p_value > max_p_value){
         next
      }
      indexes <- as.vector(rt[i*2-1,])
      values <- as.vector(rt[i*2,])
      potins_num <- length(indexes)-2
      max_x <- as.numeric(indexes[potins_num])
      max_y_index <- which.max(as.numeric(values[2:potins_num]))[1]
      max_y <- max(as.numeric(values[2:potins_num]))
      if(figKind == "none"){
         #dev.new() ;
      }
      if(figKind == "pdf"){
         proteinName <- as.vector(rt[i*2-1,1])
         pdf(paste(outputDir,"/",proteinName,".pdf",sep=""))
      }
      if(figKind == "jpeg"){
         proteinName <- as.vector(rt[i*2-1,1])
         jpeg(paste(outputDir,"/",proteinName,".jpeg",sep=""))
      }
      plot(as.numeric(indexes[2:potins_num]),y=as.numeric(values[2:potins_num]),type="l",ylim=c(-1,1),xlab=paste("site: ", indexes[1],sep=""),ylab="ES Score",col=2,lwd=3)
      #lines(c(0,max_x),c(0.9,0.9),lwd=3)
      lines(c(0,max_x),c(0,0),lty=2,col=8)
      lines(c(-1000,as.numeric(indexes[max_y_index+1])),c(max_y,max_y),lwd=1,lty=2)
      lines(c(as.numeric(indexes[max_y_index+1]),as.numeric(indexes[max_y_index+1])),c(max(-0.7,max_y-0.7),min(max_y+0.7,0.7)),lwd=1,lty=2)
      text(as.numeric(indexes[max_y_index+1])+0.05, max_y, max_y,pos=4)
      
      for(j in (2:potins_num)){
          if(j%%2==1){
             next
          }
          if(j <= max_y_index+1){
             lines(c(indexes[j],indexes[j]),c(0.8,0.95),col=rgb(0,0,200,maxColorValue = 255))
          }else{
             lines(c(indexes[j],indexes[j]),c(0.8,0.95),col=rgb(160,160,255,maxColorValue = 255))
          }
      }
      if(figKind == "pdf"){
         dev.off()
      }
      if(figKind == "jpeg"){
         dev.off()
      }
  }
})

setMethod(drawStat, "data.frame",
function(curveInfoDataFrame, proteinIds=NULL, outputDir=NULL, figKind=c("pdf","jpeg"))
{
  valid_rows <- (1:(nrow(curveInfoDataFrame)/2))*2-1
  rt <- as.matrix(curveInfoDataFrame[valid_rows,c(1,ncol(curveInfoDataFrame)-1,ncol(curveInfoDataFrame))])
  positions <- as.vector(rt[,2])
  if((!is.null(outputDir[1]))||(length(outputDir) > 1)){
      figKind <- match.arg(figKind)     
      dir.create(outputDir[1], showWarnings = FALSE, recursive = TRUE)
      #cat("create ", outputDir[1], "\n")
  }else{
      figKind <- "none"
  }
  for(i in (1:(nrow(rt)))){
      proteinName <- as.vector(rt[i,1])
      stokens <- unlist(strsplit(proteinName, "_"))
      site <- stokens[length(stokens)]
      stop <- nchar(proteinName)-nchar(site)-1
      rt[i,1]<-substr(proteinName, 1, stop)
      positions[i]<- as.numeric(site)
  }
  if((is.null(proteinIds[1]))&&(length(proteinIds) == 0)){
      proteinIds <- as.vector(rt[,1])
  }
  name2name <- c()
  name2name[proteinIds] <- proteinIds
  for(i in (1:length(name2name))){
      valid_rows <- rt[,1]==name2name[i]
      es_scores <- rt[valid_rows,2]
      p_values <- rt[valid_rows,3]
      x_values <- as.numeric(positions[valid_rows])
      if(figKind == "none"){
         #dev.new() ;
      }
      if(figKind == "pdf"){
         pdf(paste(outputDir,"/",name2name[i],".pdf",sep=""))
      }
      if(figKind == "jpeg"){
         jpeg(paste(outputDir,"/",name2name[i],".jpeg",sep=""))
      }
      plot(x_values, es_scores,pch=24,col=2,ylim=c(0,1),lwd=3,xlab=paste("sites of protein ", name2name[i],sep=""),ylab="ES & p-value")
      lines(x_values, es_scores,pch=24,col=2, lwd=2)
      points(x_values,p_values,pch=23,col=3, ylim=c(0,1),lwd=3)
      lines(x_values,p_values,pch=23,col=3, lwd=2)
      points((max(x_values)-min(x_values))/10+min(x_values), 1.0, pch=23, lwd=3, col=3)
      text((max(x_values)-min(x_values))/10*1.3+min(x_values), 1.0,label="nominal p-value",adj=0)
      points((max(x_values)-min(x_values))/10+min(x_values), 0.95, pch=24, lwd=3, col=2)
      text((max(x_values)-min(x_values))/10*1.3+min(x_values), 0.95,label="Enrichment Score",adj=0)
      if(figKind == "pdf"){
         dev.off()
      }
      if(figKind == "jpeg"){
         dev.off()
      }
  }
})

SequenceInfo <- function(sequences, ids = character(0)){
   if(length(ids) == 0){
      ids <- sequences
   }
   if(length(ids) != length(sequences)){
      ids <- sequences
      cat("Waring: length of ids is not equal to sequences!\n")
   }
   object <- new("SequenceInfo")
   sequences(object) <- sequences
   ids(object) <- ids
   object
}

setMethod(show, "SequenceInfo", function(object) {
   cat("object of SequenceInfo\n")
   cat("total", length(sequences(object)), "sequences\n")
   showRows <- length(sequences(object))
   if(showRows > 10){
      showRows = 10
   }
   cat("first", showRows, "sequences\n")
   cat("Slot \"ids\":\n")
   show(ids(object)[1:showRows])
   cat("Slot \"sequences\":\n")
   show(sequences(object)[1:showRows])
})


setMethod("sequences", "SequenceInfo", function(object) slot(object, "sequences"))
setMethod("ids", "SequenceInfo", function(object) slot(object, "ids"))

setReplaceMethod("sequences", signature("SequenceInfo", "character"),
  function(object, value) {
     slot(object,"sequences")<- value
     object
  })
  
setReplaceMethod("ids", signature("SequenceInfo", "character"),
  function(object, value) {
     slot(object,"ids")<- value
     object
  })

setGeneric("asebSites",
           function(backgroundSites, prodefinedSites, testSites, outputFile=NULL, permutationTimes=10000) standardGeneric("asebSites"), signature=c("backgroundSites", "prodefinedSites", "testSites"))
setGeneric("asebProteins",
           function(backgroundSites, prodefinedSites, testProteins, outputFile=NULL, permutationTimes=10000) standardGeneric("asebProteins"), signature=c("backgroundSites", "prodefinedSites", "testProteins"))
setGeneric("drawStat",
           function(curveInfoDataFrame, proteinIds=NULL, outputDir=NULL, figKind=c("pdf","jpeg")) standardGeneric("drawStat"), signature="curveInfoDataFrame")
setGeneric("drawEScurve",
           function(curveInfoDataFrame, sites=NULL, max_p_value=0.1, min_es=0.2, outputDir=NULL, figKind=c("pdf","jpeg")) standardGeneric("drawEScurve"), signature="curveInfoDataFrame")

setGeneric("sequences", function(object) standardGeneric("sequences"))

setGeneric("ids", function(object) standardGeneric("ids"))

setGeneric("sequences<-", function(object, value) standardGeneric("sequences<-"))

setGeneric("ids<-", function(object, value) standardGeneric("ids<-"))

%\VignetteIndexEntry{ASEB}
%\VignetteKeywords{lysine (K)-acetyl-transferase (KAT) acetylation}
%\VignettePackage{ASEB}

\documentclass[11pt]{article}
\usepackage{Sweave}
\usepackage{amsmath}
\usepackage{hyperref}
\usepackage[authoryear,round]{natbib}

\setlength{\textheight}{8.5in}
\setlength{\textwidth}{6in}
\setlength{\topmargin}{-0.25in}
\setlength{\oddsidemargin}{0.25in}
\setlength{\evensidemargin}{0.25in}
\newcommand{\Rpackage}[1]{{\textit{#1}}}

\begin{document}
\title{\bf How to use the ASEB Package}
\author{Likun Wang$^1$$^,$$^2$ and Tingting Li$^1$$^,$$^3$}
\maketitle
\noindent
$^1$Institute of Systems Biomedicine, Peking University Health Science Center.\\
\noindent
$^2$College of Computer Science and Technology, Jilin University.\\
\noindent
$^3$Department of Biomedical Informatics, Peking University Health Science Center.\\
\begin{center}
{\tt wanglk@pku.edu.cn}
\end{center}
\tableofcontents

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Introduction}

Lysine acetylation is a well-studied posttranslational modification on kinds of proteins. 
About four thousand lysine acetylation sites and over 20 lysine (K)-acetyl-transferases (KATs) have been identified. 
However, which KAT is responsible for a given protein or lysine site acetylation is mostly unknown. 
In our previous study, we found that different KAT families acetylate lysine sites with different sequence features \citep{Li03}. 
Based on these differences, we developed a computer program, Acetylation Set Enrichment Based (ASEB) method to
predict which KAT-families are responsible for acetylation of a given protein or lysine site.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Getting started}
To load the \Rpackage{ASEB} package, type {\tt library(ASEB)}. 
Total six methods are presented in this package. They are {\tt readSequence}, {\tt asebSites}, 
{\tt asebProteins}, {\tt drawStat} and {\tt drawEScurve}.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Methods}
In this package, we use a GSEA-like method to make predictions.
Gene Set Enrichment Analysis (GSEA) method was developed and successfully used to detect coordinated expression changes  \citep{Subramanian05, Mootha03}
and find the putative functions of the long non-coding RNAs \citep{Guttman09}.   
In our study \citep{Li03}, we treated the (acetylated) lysine sites and their surrounding amino acids (8 on each side) as (acetylated) peptide sequences.
We first define all the validated acetylated peptide sequences from one KAT family as a KAT-specific set, 
and define 10000 random selected peptide sequences from the whole proteome as a background set. 
When given a new query peptide sequence, similarity scores are calculated according to the BLOSUM62 matrix between this query peptide and peptides in the KAT-specific set 
and background set. A list is then created by ranking the scores. 
Similar with GSEA method, a running sum score (enrichment score) was calculated by walking down the list. 
To estimate the significance of the enrichment score for a query peptide, at first, 
a certain number of peptide sets with the same size as KAT-specific set was randomly generated.
Secondly, treating each randomly generated set as a pseudo predefined KAT-specific set, an enrichment score can be calculated for each randomly generated set.  
At last, rank all the enrichment scores (from high to low) and a nominal P-value could be calculated.
The nominal P-value is defined as the rank of enrichment score for the KAT-specific set divided by the total number of random selected sets.
The whole process is similar with the GSEA method (permuting gene sets). Please see \cite{Li03} for details.

\section{Data}
We provide the KAT-specific set for CBP/P300 and GCN5/PCAF family in this package.
The file predefined\_sites.fa under extdata contains the KAT-specific set for CBP/P300 family (total 267 sites). 
While the file predefined\_sites2.fa contains the KAT-specific set for GCN5/PCAF family (total 82 sites). 
The two sets were generated by searching the PubMed literature.
The file background\_sites.fa contains 10000 randomly selected sites and the KAT-specific set for CBP/P300 family (total 10000+267 sites).
While the file background\_sites2.fa contains 10000 randomly selected sites and the KAT-specific set for GCN5/PCAF family (total 10000+82 sites).
\section{Examples}
\subsection{Example for readSequence}
This function return an object of {\tt SequenceInfo} that contains sequences and identifiers from FASTA format input file.  
\begin{center}
<<echo=TRUE,print=FALSE>>=
  library(ASEB)
  ff <- system.file("extdata", "background_sites.fa", package="ASEB")
  readSequence(ff)
@
\end{center}
\noindent

\subsection{Example for asebSites}
This function is used to predict lysine sites that can be acetylated by a specific KAT-family.  
\begin{center}
<<echo=TRUE,print=FALSE>>=
  backgroundSites <- readSequence(system.file("extdata", "background_sites.fa", package="ASEB")) 
  prodefinedSites <- readSequence(system.file("extdata", "predefined_sites.fa", package="ASEB"))
  testSites <- readSequence(system.file("extdata", "sites_to_test.fa", package="ASEB"))
  resultList <- asebSites(backgroundSites, prodefinedSites, testSites, permutationTimes=100)
  resultList$results[1:2,]
@
\end{center}
This method can also process FASTA format files directly 
without loading all the sequences to the workspace of R.
In this case, it can process huge number of lysine sites each time.
\begin{center}
<<echo=TRUE,print=FALSE>>=
  backgroundSitesFile <- system.file("extdata", "background_sites.fa", package="ASEB")
  prodefinedSitesFile <- system.file("extdata", "predefined_sites.fa", package="ASEB")
  testSitesFile <- system.file("extdata", "sites_to_test.fa", package="ASEB")
  asebSites(backgroundSitesFile, prodefinedSitesFile, testSitesFile, permutationTimes=100)
@
\end{center}
\noindent
\subsection{Example for drawEScurve}
This method can be used to draw enrichment score curve for a specific site.
Please see \cite{Li03} for details about enrichment score curve. 
\begin{center}
<<echo=TRUE,print=FALSE, fig=TRUE>>=
  drawEScurve(resultList$curveInfo, max_p_value=0.1, min_es=0.1)
@
\end{center}
These curves show running-sum process for calculating enrichment score.
Users can find detail algorithm from \cite{Li03}.
The data.frame object contains curve information is given by {\tt asebSites}, 
or {\tt asebProteins}.
\subsection{Example for asebProteins}
This function is used to predict all lysine sites on a specific protein that can be acetylated by a specific KAT-family. 
\begin{center}
<<echo=TRUE,print=FALSE,results=hide>>=
  backgroundSites <- readSequence(system.file("extdata", "background_sites.fa", package="ASEB")) 
  prodefinedSites <- readSequence(system.file("extdata", "predefined_sites.fa", package="ASEB"))
  testProteins <- readSequence(system.file("extdata", "proteins_to_test.fa", package="ASEB"))
  resultList <- asebProteins(backgroundSites, prodefinedSites, testProteins, permutationTimes=100)
  resultList$results[1:2,]
@
\end{center}
For processing huge number of lysine sites on proteins, this method can be used as below.
\begin{center}
<<echo=TRUE,print=FALSE,results=hide>>=
  backgroundSitesFile <- system.file("extdata", "background_sites.fa", package="ASEB")
  prodefinedSitesFile <- system.file("extdata", "predefined_sites.fa", package="ASEB")
  testProteinsFile <- system.file("extdata", "sites_to_test.fa", package="ASEB")
  asebProteins(backgroundSitesFile, prodefinedSitesFile, testProteinsFile, permutationTimes=100)
@
\end{center}
\subsection{Example for drawStat}
This function is used to show P-values and enrichment scores for all lysine sites on a specific protein.
The X-axis shows positions of all lysine sites on a specific protein, and Y-axis shows the enrichment scores (0~1) and P-values (0~1)
for each lysine site. 
\begin{center}
<<echo=TRUE,print=FALSE,results=hide, fig=TRUE>>=
  drawStat(curveInfoDataFrame=resultList$curveInfo);
@
\end{center}
The sites with less P-values are more significant.
For sites that have similar P-values, the ones with higher enrichment scores are more likely to be 
acetylated. These P-values are nominal \citep{Subramanian05, Mootha03}, hence it is hard to
give an threshold to predict significant sites. However, users can order all the sites 
and pay more attention to the ones with relatively less P-values.
Please see \cite{Li03} for details.
\noindent

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%\newpage
\bibliographystyle{apalike}
\bibliography{ASEB}
\end{document}

\name{asebSites}
\alias{asebSites}
\alias{asebSites,SequenceInfo,SequenceInfo,SequenceInfo-method}
\alias{asebSites,character,character,character-method}
\title{prediction of lysine sites that can be acetylated}
\description{
   This function is used to predict lysine sites that can be acetylated by a specific KAT-family.  
}
\usage{
asebSites(backgroundSites, prodefinedSites, testSites, outputFile=NULL, permutationTimes=10000)
\S4method{asebSites}{character,character,character}(backgroundSites, prodefinedSites, testSites, outputFile=NULL, permutationTimes=10000)
\S4method{asebSites}{SequenceInfo,SequenceInfo,SequenceInfo}(backgroundSites, prodefinedSites, testSites, outputFile=NULL, permutationTimes=10000)
}
\arguments{
 \item{backgroundSites}{\link{SequenceInfo} object or file name (character(1)) for background peptides set.}
 \item{prodefinedSites}{\link{SequenceInfo} object or file name (character(1)) for KAT special peptides set.}
 \item{testSites}{\link{SequenceInfo} object or file name (character(1)) for query peptides set.}
 \item{outputFile}{file name for output (character(1)).}
 \item{permutationTimes}{permutation times (integer(1)), default and recommended: 10000.}
}
\details{
  This function is used to predict lysine sites that can be acetylated by a specific KAT-family.
  It will give an enrichment score and a P-value for each query lysine site.
  The whole process is similar with the GSEA method (permuting gene sets). Please see the references for details. \cr
  
  The first three arguments of method asebSites can be \link{SequenceInfo} objects or file names.
  If these arguments are \link{SequenceInfo} objects, this method returns a list to the users besides an output file.
  Otherwise, this method processes the FASTA format files directly and outputs all results to a file. 
  In this case, this method can process huge number of sites each time without loading any sequences to R workspace.
}
\value{
  The output file contains enrichment scores and P-values for each query site.
  The \code{asebSites,SequenceInfo,SequenceInfo,SequenceInfo-method} also returns a list contains two \code{data.frame} objects: \code{results} and \code{curveInfo}.
  \item{results}{contains enrichment scores and P-values for each query site.}
  \item{curveInfo}{contains information for enrichment score curves.}
}
\note{
  The acetylated lysine sites and their surrounding amino acids (8 on each side) are treated as acetylated peptides. \cr
  Example for peptides sequence :  "KEHDDIFDKLKEAVKEE". \cr
  All input file should follow FASTA format. 
}
\references{
 Subramanian, A. et al. (2005) Gene set enrichment analysis: a knowledge-based approach for interpreting genome-wide expression profiles. 
 \emph{Proc Natl Acad Sci U S A}, \bold{102}, 15545-15550.
 
 Mootha, V.K. et al. (2003) PGC-1alpha-responsive genes involved in oxidative phosphorylation are coordinately downregulated in human diabetes.
 \emph{Nat Genet}, \bold{34}, 267-273.
 
Guttman, M. et al. (2009) Chromatin signature reveals over a thousand highly conserved large non-coding RNAs in mammals. 
\emph{Nature},  \bold{458}, 223-227.

Li, T.T. et al. Characterization and prediction of lysine (K)-acetyl-transferase (KAT) specific acetylation sites.
\emph{Mol Cell Proteomics}, \bold{in press}.
}
\seealso{
 \code{\link{SequenceInfo}},
 \code{\link{readSequence}},
 \code{\link{asebProteins}},
 \code{\link{drawStat}},
 \code{\link{drawEScurve}}.
}
\examples{
    backgroundSites <- readSequence(system.file("extdata", "background_sites.fa", package="ASEB")) 
    prodefinedSites <- readSequence(system.file("extdata", "predefined_sites.fa", package="ASEB"))
    testSites <- readSequence(system.file("extdata", "sites_to_test.fa", package="ASEB"))
    resultList <- asebSites(backgroundSites, prodefinedSites, testSites, permutationTimes=100)
    resultList$results[1:2,]
}
\keyword{methods}

\name{asebProteins}
\alias{asebProteins}
\alias{asebProteins,SequenceInfo,SequenceInfo,SequenceInfo-method}
\alias{asebProteins,character,character,character-method}
\title{prediction of all lysine sites on a specific protein that can be acetylated}
\description{
   This function is used to predict all lysine sites on a specific protein that can be acetylated by a specific KAT-family.   
}
\usage{
asebProteins(backgroundSites, prodefinedSites, testProteins, outputFile=NULL, permutationTimes=10000)
\S4method{asebProteins}{character,character,character}(backgroundSites, prodefinedSites, testProteins, outputFile=NULL, permutationTimes=10000)
\S4method{asebProteins}{SequenceInfo,SequenceInfo,SequenceInfo}(backgroundSites, prodefinedSites, testProteins, outputFile=NULL, permutationTimes=10000)
}
\arguments{
 \item{backgroundSites}{\link{SequenceInfo} object or file name (character(1)) for background peptides set.}
 \item{prodefinedSites}{\link{SequenceInfo} object or file name (character(1)) for KAT special peptides set.}
 \item{testProteins}{\link{SequenceInfo} object or file name (character(1)) for query Proteins set.}
 \item{outputFile}{file name for output (character(1)).}
 \item{permutationTimes}{permutation times (integer(1)), default and recommended: 10000.}
}
\details{
  This function is used to predict lysine sites that can be acetylated by a specific KAT-family.
  The whole process is similar with the GSEA method (permuting gene sets). Please see the references for details. \cr
  
  The first three arguments of method asebProteins can be \link{SequenceInfo} objects or file names.
  If these arguments are \link{SequenceInfo} objects, this method returns a list to the users besides an output file.
  Otherwise, this method processes the FASTA format files directly and outputs all results to a file. 
  In this case, this method can process huge number of sites each time without loading any sequences to R workspace.
}
\value{
  The output file contains enrichment scores and P-values for each query site.
  The \code{asebProteins,SequenceInfo,SequenceInfo,SequenceInfo-method} also returns a list contains two \code{data.frame} objects: \code{results} and \code{curveInfo}.
  \item{results}{contains enrichment scores and P-values for each query site.}
  \item{curveInfo}{contains information for enrichment score curves.}
}
\note{
The acetylated lysine sites and their surrounding amino acids (8 on each side) are treated as acetylated peptides. \cr
Example for peptides sequence :  "KEHDDIFDKLKEAVKEE". \cr
All input file should follow FASTA format.
}
\references{
  Subramanian, A. et al. (2005) Gene set enrichment analysis: a knowledge-based approach for interpreting genome-wide expression profiles. 
 \emph{Proc Natl Acad Sci U S A}, \bold{102}, 15545-15550.
 
 Mootha, V.K. et al. (2003) PGC-1alpha-responsive genes involved in oxidative phosphorylation are coordinately downregulated in human diabetes.
 \emph{Nat Genet}, \bold{34}, 267-273.
 
Guttman, M. et al. (2009) Chromatin signature reveals over a thousand highly conserved large non-coding RNAs in mammals. 
\emph{Nature},  \bold{458}, 223-227.

Li, T.T. et al. Characterization and prediction of lysine (K)-acetyl-transferase (KAT) specific acetylation sites.
\emph{Mol Cell Proteomics}, \bold{in press}.
}
\seealso{
 \code{\link{SequenceInfo}},
 \code{\link{readSequence}},
 \code{\link{asebSites}},
 \code{\link{drawStat}},
 \code{\link{drawEScurve}}.
}
\examples{
    backgroundSites <- readSequence(system.file("extdata", "background_sites.fa", package="ASEB")) 
    prodefinedSites <- readSequence(system.file("extdata", "predefined_sites.fa", package="ASEB"))
    testProteins <- readSequence(system.file("extdata", "proteins_to_test.fa", package="ASEB"))
    resultList <- asebProteins(backgroundSites, prodefinedSites, testProteins, permutationTimes=100)
    resultList$results[1:2,]
}
\keyword{methods}

\name{drawStat}
\alias{drawStat}
\alias{drawStat,data.frame-method}
\title{draw P-values and enrichment scores for all lysine sites on a specific protein}
\description{
   This function is used to show P-values and enrichment scores for all lysine sites on a specific protein.
}
\usage{
drawStat(curveInfoDataFrame, proteinIds=NULL, outputDir=NULL, figKind=c("pdf","jpeg"))
\S4method{drawStat}{data.frame}(curveInfoDataFrame, proteinIds=NULL, outputDir=NULL, figKind=c("pdf","jpeg"))
}
\arguments{
\item{curveInfoDataFrame}{data.frame object: contains curve information for all proteins, see example.}
\item{proteinIds}{character vector: only draw curves for proteins with ids appear in this vector. \cr
                  default: draw curves for all the proteins appear in curveInfoDataFrame.}
\item{outputDir}{character(1), output directory name for all the figures.}
\item{figKind}{character(1), fig format: \code{"pdf"} or \code{"jpeg"}.}
}
\details{
  This function is used to draw P-values and enrichment scores for all lysine sites on a specific protein.
  The X-axis shows positions of all lysine sites on a specific protein, and Y-axis shows the enrichment scores (0~1) and P-values (0~1)
  for each lysine site. The data.frame object contains curve information is given by \code{\link{asebProteins}}. 
}
\seealso{
 \code{\link{SequenceInfo}},
 \code{\link{readSequence}},
 \code{\link{asebSites}},
 \code{\link{asebProteins}},
 \code{\link{drawEScurve}}.
}
\examples{
    backgroundSites <- readSequence(system.file("extdata", "background_sites.fa", package="ASEB")) 
    prodefinedSites <- readSequence(system.file("extdata", "predefined_sites.fa", package="ASEB"))
    testProteins <- readSequence(system.file("extdata", "proteins_to_test.fa", package="ASEB"))
    resultList <- asebProteins(backgroundSites, prodefinedSites, testProteins, permutationTimes=100)
    #drawEScurve(resultList$curveInfo, max_p_value=0.5, min_es=0, outputDir=tempdir(), figKind="jpeg")
    drawStat(resultList$curveInfo, outputDir=tempdir(), figKind="jpeg");
    cat("see figures in output dir:", tempdir(),"\n")
}
\keyword{methods}

\name{readSequence}
\alias{readSequence}
\title{read sequences from file}
\description{
   This function is used to read sequences from FASTA format file.  
}
\usage{
readSequence(file)
}
\arguments{
 \item{file}{character(1), file name for input. \cr The input file should follow FASTA format.}
}
\details{
  This function return an object of \code{\link{SequenceInfo}} that 
  contains sequences and identifiers from FASTA format input file.
}
\value{
  A \code{\link{SequenceInfo}} object containing sequences and identifiers from input file. 
}
\seealso{
 \code{\link{SequenceInfo}},
 \code{\link{asebSites}},
 \code{\link{asebProteins}},
 \code{\link{drawStat}},
 \code{\link{drawEScurve}}.
}
\examples{
   ff <- system.file("extdata", "background_sites.fa", package="ASEB")
   readSequence(ff)
}
\keyword{methods}

\name{SequenceInfo}
\docType{class}
\alias{SequenceInfo}
\title{"SequenceInfo" class}

\description{
  This class is used to store sequences and identifiers for lysine sites or proteins.
}

\section{Objects from the Class}{
  Objects from this class are created by constructor \code{SequenceInfo}, as outlined below.
}

\section{Slots}{
  \describe{
    \item{\code{sequences}:}{\code{"character"}
      containing sequences.}
    \item{\code{id}:}{\code{"character"} containing identifiers.}
  }
}

\section{Methods}{
  Constructor:
  \describe{
    \item{SequenceInfo}{\code{signature(sequences = "character", id = "character")}:
      Create a \code{SequenceInfo} object from sequences and their
      identifiers. The length of \code{id} must match that of \code{sequences}.}
  }
}
\seealso{
 \code{\link{readSequence}},
 \code{\link{asebSites}},
 \code{\link{asebProteins}},
 \code{\link{drawStat}},
 \code{\link{drawEScurve}}.
}
\examples{
showClass("SequenceInfo")
}
\keyword{classes}

\name{drawEScurve}
\alias{drawEScurve}
\alias{drawEScurve,data.frame-method}
\title{draw Enriment Score curves for specific sites}
\description{
   This function is used to draw Enriment Score curves for specific sites.
}
\usage{
drawEScurve(curveInfoDataFrame, sites=NULL, max_p_value=0.1, min_es=0.2, outputDir=NULL, figKind=c("pdf","jpeg"))
\S4method{drawEScurve}{data.frame}(curveInfoDataFrame, sites=NULL, max_p_value=0.1, min_es=0.2, outputDir=NULL, figKind=c("pdf","jpeg"))
}
\arguments{
\item{curveInfoDataFrame}{data.frame object: contains curve information for sites, see example.}
\item{sites}{character vector: only draw curves for sites with ids appear in this vector. \cr
             default: draw curves for all the sites appear in curveInfoDataFrame.}
\item{max_p_value}{numeric(1), only draw curves for sites with p-value less than this value.}
\item{min_es}{numeric(1), only draw curves for sites with Enriment Score more than this value.}
\item{outputDir}{character(1), output directory name for all the figures.}
\item{figKind}{character(1), fig format: \code{"pdf"} or \code{"jpeg"}.}
}
\details{
  This function is used to draw Enrichment Score curves for specific sites.
  These curves show running-sum process for calculating enrichment score.
  The data.frame object contains curve information is given by 
  \code{\link{asebSites}} or \code{\link{asebProteins}}. 
}
\seealso{
 \code{\link{SequenceInfo}},
 \code{\link{readSequence}},
 \code{\link{asebSites}},
 \code{\link{asebProteins}},
 \code{\link{drawStat}}.
}
\examples{
    backgroundSites <- readSequence(system.file("extdata", "background_sites.fa", package="ASEB")) 
    prodefinedSites <- readSequence(system.file("extdata", "predefined_sites.fa", package="ASEB"))
    testSites <- readSequence(system.file("extdata", "sites_to_test.fa", package="ASEB"))
    resultList <- asebSites(backgroundSites, prodefinedSites, testSites, permutationTimes=100)
    drawEScurve(resultList$curveInfo, max_p_value=0.1, min_es=0.1, outputDir=tempdir(), figKind="jpeg")
    cat("see figures in output dir:", tempdir(),"\n")
}
\keyword{methods}
